﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;
using System.IO;
using System.Diagnostics;

namespace CutImage
{
    public partial class Form1 : Form
    {

        string outputDir = "";

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (!System.IO.File.Exists(this.textBoxImgPath.Text.Trim()))
            {
                MessageBox.Show("请选择需要分割的图片文件", "错误");
                this.textBoxImgPath.Focus();
            }
            else
            {
                try
                {
                    string imgPath = this.textBoxImgPath.Text;
                    Bitmap image = new Bitmap(imgPath);//从TextBox里获得图像的路径
                    int Height = image.Height;//图像高度
                    int Width = image.Width;//图像宽度
                    int x = Convert.ToInt32(this.comboBoxWidth.Text);//横切x份
                    int y = Convert.ToInt32(this.comboBoxHeight.Text);//纵切y份

                    outputDir = imgPath.Substring(0, imgPath.LastIndexOf('.'));
                    if (!Directory.Exists(outputDir))
                    {
                        Directory.CreateDirectory(outputDir);
                    }
                    for (byte i = 0; i < x; i++)
                    {
                        for (byte j = 0; j < y; j++)
                        {
                            RectangleF part = new RectangleF(i * Width / x, j * Height / y, Width / x, Height / y);//像素矩阵
                            Bitmap s = image.Clone(part, PixelFormat.DontCare);//将原图的部分存为新的Bitmap
                            string ss = outputDir + "/" + i + j + ".jpg";//输出路径
                            s.Save(ss, ImageFormat.Jpeg);//保存
                        }
                    }
                    this.buttonOpenResult.Enabled = true;
                    MessageBox.Show("分割完成.", "提示");
                }
                catch(Exception ex)
                {
                    if (ex.Message == "Parameter is not valid.")
                    {
                        MessageBox.Show("文件不存在或者文件不是图片文件", "错误");
                        this.textBoxImgPath.Focus();
                    }
                    else
                    {
                        MessageBox.Show("发生错误：" + ex.Message + "\n详细：" + ex.StackTrace, "错误");
                    }
                }
               
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ProcessStartInfo sInfo = new ProcessStartInfo("http://www.buxiaoyang.com/imgcutter/");
            Process.Start(sInfo);
        }

        private void buttonBroswerImg_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.InitialDirectory = "c://";
            openFileDialog.Filter = "图片文件(*.bmp, *.jpg, *.png)|*.bmp;*.jpg;*.png|所有文件|*.*";
            openFileDialog.RestoreDirectory = true;
            openFileDialog.FilterIndex = 1;
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                this.textBoxImgPath.Text = openFileDialog.FileName;
                this.buttonOpenResult.Enabled = false;
            }
        }

        private void linkLabel2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ProcessStartInfo sInfo = new ProcessStartInfo("http://www.buxiaoyang.com/");
            Process.Start(sInfo);
        }

        private void buttonOpenResult_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(outputDir);
        }
    }
}
